<edit file>
$boarddir/index.php
</edit file>

<search for>
* Software Version:           SMF 1.0.13                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
$forum_version = 'SMF 1.0.13';
</search for>

<replace>
$forum_version = 'SMF 1.0.14';
</replace>

<search for>
// Seed the random generator for PHP < 4.2.0.
if (@version_compare(PHP_VERSION, '4.2.0') == -1)
{
	if (empty($modSettings['rand_seed']))
	{
		$modSettings['rand_seed'] = microtime() * 1000000;
		updateSettings(array('rand_seed' => $modSettings['rand_seed']));
	}
	$seed = ($modSettings['rand_seed'] + ((double) microtime() * 1000003)) & 0x7fffffff;
	srand($seed);
	// Change the seed?
	if (rand(1, 250) == 69)
		updateSettings(array('rand_seed' => rand()));
}
</search for>

<replace>
// Seed the random generator?
if (empty($modSettings['rand_seed']) || mt_rand(1, 250) == 69)
	smf_seed_generator();
</replace>

<edit file>
$boarddir/SSI.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
// Load installed 'Mods' settings.
reloadSettings();
// Clean the request variables.
cleanRequest();
</search for>

<replace>
// Load installed 'Mods' settings.
reloadSettings();
// Clean the request variables.
cleanRequest();

// Seed the random generator?
if (empty($modSettings['rand_seed']) || mt_rand(1, 250) == 69)
	smf_seed_generator();
</replace>

<search for>
	// Note that PHP 4.2.x and above, only, auto-seed.
	if (@version_compare(PHP_VERSION, '4.2.0') == -1)
		srand(time());
</search for>

<replace>
	// Note that PHP 4.2.x and above, only, auto-seed.
	if (@version_compare(PHP_VERSION, '4.2.0') == -1)
		mt_srand(time());
</replace>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
			$_COOKIE[session_name()] = md5(md5('smf_sess_' . time()) . rand());
</search for>

<replace>
			$_COOKIE[session_name()] = md5(md5('smf_sess_' . time()) . mt_rand());
</replace>

<search for>
		$_SESSION['rand_code'] = md5(session_id() . rand());
</search for>

<replace>
		$_SESSION['rand_code'] = md5(session_id() . mt_rand());
</replace>

<edit file>
$sourcedir/Profile.php
</edit file>

<search for>
* Software Version:           SMF 1.0.13                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
				$validationCode = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
</search for>

<replace>
				$validationCode = generateValidationCode();
</replace>

<edit file>
$sourcedir/Register.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
		$password = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
</search for>

<replace>
		$password = generateValidationCode();
</replace>

<search for>
		srand(time() + 1277);
</search for>

<replace>
		mt_srand(time() + 1277);
</replace>

<search for>
		$_POST['passwrd1'] = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
</search for>

<replace>
		$_POST['passwrd1'] = generateValidationCode();
</replace>

<edit file>
$sourcedir/Reminder.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
	$password = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
</search for>

<replace>
	$password = generateValidationCode();
</replace>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
* Software Version:           SMF 1.0.12                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
	$context['random_news_line'] = $context['news_lines'][rand(0, count($context['news_lines']) - 1)];
</search for>

<replace>
	$context['random_news_line'] = $context['news_lines'][mt_rand(0, count($context['news_lines']) - 1)];
</replace>

<search for>

?>
</search for>

<replace>
// Generate a random validation code.
function generateValidationCode()
{
	global $modSettings;

	$request = db_query('
		SELECT RAND()', __FILE__, __LINE__);

	list ($dbRand) = mysql_fetch_row($request);
	mysql_free_result($request);

	return substr(preg_replace('/\W/', '', sha1(microtime() . mt_rand() . $dbRand . $modSettings['rand_seed'])), 0, 10);	
}


// Generate a random seed and ensure it's stored in settings.
function smf_seed_generator()
{
	global $modSettings;

	// Never existed?
	if (empty($modSettings['rand_seed']))
	{
		$modSettings['rand_seed'] = microtime() * 1000000;
		updateSettings(array('rand_seed' => $modSettings['rand_seed']));
	}

	if (@version_compare(PHP_VERSION, '4.2.0') == -1)
	{
		$seed = ($modSettings['rand_seed'] + ((double) microtime() * 1000003)) & 0x7fffffff;
		mt_srand($seed);
	}

	// Change the seed.
	updateSettings(array('rand_seed' => mt_rand()));
}


?>
</replace>

<edit file>
$sourcedir/Subs-Auth.php
</edit file>

<search for>
* Software Version:           SMF 1.0.11                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.14                                          *
</replace>

<search for>
		session_id(strtolower(md5(uniqid(rand(), true))));
</search for>

<replace>
		session_id(strtolower(md5(uniqid(mt_rand(), true))));
</replace>

<search for>
	$newPassword = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
</search for>

<replace>
	$newPassword = generateValidationCode();
</replace>